angular.module('ufind1.controllers')

.controller('areaCtrl', function($scope, $ionicHistory, $timeout, $stateParams, locationService, systemService, bleService, geoLocationService,$state) {
	var system = systemService.all();
	switch ($stateParams.id) {
		case "0":
			$scope.data = {
				volume: system.silentArea1Radius
			};
			break;
		case "1":
			$scope.data = {
				volume: system.silentArea2Radius
			};
			break;
		case "2":
			$scope.data = {
				volume: system.silentArea3Radius
			};
			break;
		default:
			console.log("$stateParams.id error");
	}
        $scope.areaonClickSetting = function () {
            $state.go("setting");
        };
	$scope.width = document.documentElement.clientWidth;
	$scope.height = document.documentElement.clientHeight - 120;
	console.log("areaCtrl width: " + $scope.width, ", height: ", $scope.height);

	var longitude;
	var latitude;
	var lgn;
	var lat;

	var currentPlatform = ionic.Platform.platform();
	if (currentPlatform == 'win32' || currentPlatform == 'macintel') {
		longitude = 114.2249847839605;
		latitude = 22.68722230099834;
	} else {
		if (typeof(geoLocationService) != "undefined") {
           
			geoLocationService.getCurrentPosition({
					timeout: 10000,
					enableHighAccuracy: false
				})
				.then(function(position) {
					switch ($stateParams.id) {
						case "0":
							if (system.silentArea1x0 == 0.0 && system.silentArea1y0 == 0.0) {
								longitude = position.coords.longitude;
								latitude = position.coords.latitude;
                      console.log("dingwei"+longitude, latitude);
							} else {
                                lgn = system.silentArea1x0;
								lat = system.silentArea1y0;
                      
							}
							break;
						case "1":
							if (system.silentArea2x0 == 0.0 && system.silentArea2y0 == 0.0) {
								longitude = position.coords.longitude;
								latitude = position.coords.latitude;
							} else {

                                lgn = system.silentArea2x0;
								lat = system.silentArea2y0;
							}
							break;
						case "2":
							if (system.silentArea3x0 == 0.0 && system.silentArea3y0 == 0.0) {
								longitude = position.coords.longitude;
								latitude = position.coords.latitude;
							} else {
                                lgn = system.silentArea3x0;
								lat = system.silentArea3y0;
							}
							break;
					}
					var baiduPoint;
					var map;
					var pt = new BMap.Point(longitude, latitude);
					var circle;
					var ppt;

					map = new BMap.Map("myArea", {
						minZoom: 15
					});
					if (typeof(lng) != "undefined" && typeof(lat) != "undefined") {
						ppt = new BMap.Point(lng, lat);
						map.centerAndZoom(ppt, 16);
					} else {
						var translateCallback = function(point) {
							baiduPoint = point;
							console.log("baiduPoint is: " + JSON.stringify(baiduPoint));
							ppt = new BMap.Point(baiduPoint.lng, baiduPoint.lat);
							map.centerAndZoom(ppt, 16);
						};
						BMap.Convertor.translate(pt, 0, translateCallback);
					}
					map.addEventListener('movestart', function() {
						console.log("movestart");
						circle.hide();
					});
					map.addEventListener('moveend', function() {
						console.log("moveend");
						circle.setCenter(map.getCenter());
                        lgn = map.getCenter().lgn;
						lat = map.getCenter().lat;
						console.log(lng, lat);
						circle.show();
					});
					circle = new BMap.Circle(
						map.getCenter(),
						$scope.data.volume, {
							strokeColor: "red",
							strokeWeight: 2,
							strokeOpacity: 0.5,
							fillColor: "red",
							fillOpacity: 0.1
						}
					);
					map.clearOverlays();
					map.addOverlay(circle);

					$scope.onRangeChanged = function() {
						console.log("range changed: ", $scope.data.volume);
						if (angular.isDefined(map)) {
							circle.setRadius($scope.data.volume);
							circle.setCenter(map.getCenter());
							map.clearOverlays();
							map.addOverlay(circle);
						}
					};

					$scope.onClickFinishArea = function() {
						console.log("area.js $stateParams.id is: " + $stateParams.id);
						switch ($stateParams.id) {
							case "0":
								system.silentArea1x0 = lng;
								system.silentArea1y0 = lat;
								system.silentArea1Radius = $scope.data.volume;

								if (currentPlatform == 'ios' || currentPlatform == 'android') {
									bleService.setOption("", "cmdSilentArea1x0", lng);
									bleService.setOption("", "cmdSilentArea1y0", lat);
									bleService.setOption("", "cmdSilentArea1Radius", $scope.data.volume);
								}

								break;
							case "1":
								console.log("222" + lng, lat);
								system.silentArea2x0 = lng;
								system.silentArea2y0 = lat;
								system.silentArea2Radius = $scope.data.volume;

								if (currentPlatform == 'ios' || currentPlatform == 'android') {
									bleService.setOption("", "cmdSilentArea2x0", lng);
									bleService.setOption("", "cmdSilentArea2y0", lat);
									bleService.setOption("", "cmdSilentArea2Radius", $scope.data.volume);
								}

								break;
							case "2":
								system.silentArea3x0 = lng;
								system.silentArea3y0 = lat;
								system.silentArea3Radius = $scope.data.volume;

								if (currentPlatform == 'ios' || currentPlatform == 'android') {
									bleService.setOption("", "cmdSilentArea3x0", lng);
									bleService.setOption("", "cmdSilentArea3y0", lat);
									bleService.setOption("", "cmdSilentArea3Radius", $scope.data.volume);
								}

								break;
							default:
								break;
						}

						console.log("area.js new system is: " + JSON.stringify(system));
						systemService.serialize();

						$ionicHistory.goBack();
					};
				}, function(err) {
					console.log("unable to find location");
					$scope.errorMsg = "Error : " + err.message;
				});
		}
	}
});