angular.module('ufind1.controllers')

    .controller('configCtrl', function ($rootScope, $scope, $state, $stateParams, $ionicActionSheet, $ionicPopup, $interval, $timeout, $ionicSlideBoxDelegate, cameraService, deviceService, bleService, itemService, systemService,serviceImagePicker, $ionicLoading, $translate) {

        var currentPlatform = ionic.Platform.platform();
        var system = systemService.all();
        $scope.screen_width = document.body.clientWidth;
        $scope.device = deviceService.get($stateParams.id);

        $scope.$on('$ionicView.afterEnter', function() {
            $scope.device = deviceService.get($stateParams.id);
        });

        $scope.onClickEditName = function () {
            $scope.data = {name : $scope.device.name};
            var myPopup = $ionicPopup.show({
                template: '<input ng-model="data.name" maxlength="6">',
                title: $translate.instant('modify_name',"","",""),
                subTitle: $translate.instant('modify_bound_name',"","",""),
                scope: $scope,
                buttons: [
                    {
                        text: $translate.instant('cancel',"","",""),
                        onTap: function () {
                            return $scope.device.name;
                        }
                    },
                    {
                        text: '<b>' + $translate.instant('save',"","","") + '</b>',
                        type: 'button-positive',
                        onTap: function (e) {
                            if (!$scope.data.name) {
                                e.preventDefault();
                            } else {
                                return $scope.data.name;
                            }
                        }
                    }
                ]
            });
            myPopup.then(function (res) {
                $scope.device.name = res;
                deviceService.serialize();
                $rootScope.$broadcast('devices.refresh', $scope.device);
            });
        };

        $scope.onClicktakePhoto = function () {
            $ionicActionSheet.show({
                buttons: [
                    {
                        text: '<i class="icon ion-share"></i> ' + $translate.instant('from_photo',"","","")
                    },
                    {
                        text: '<i class="icon ion-arrow-move"></i> ' + $translate.instant('from_camera',"","","")
                    }
                ],
                cancelText: 'Cancel',
                cancel: function () {
                },
                buttonClicked: function (index) {
                    if (index == 0) {
                        if (currentPlatform == "android") {
                            var cameraOptions = {
                                maximumImagesCount: 1,
                                width: 100,
                                height: 100,
                                allowEdit: true,
                                quality: 100
                            };
                            serviceImagePicker.getPictures(cameraOptions).then(function (imageData) {
                                $scope.device.imageURI = imageData;
                                deviceService.serialize();
                                $rootScope.$broadcast('devices.refresh', $scope.device);
                            }, function (err) {
                                console.log(err);
                            });
                        } else if(currentPlatform == "ios"){
                            var cameraOptions = {
                                quality: 100,
                                destinationType: Camera.DestinationType.FILE_URI,
                                sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                                allowEdit: true,
                                encodingType: Camera.EncodingType.JPEG,
                                targetWidth: 300,
                                targetHeight: 300,
                                mediaType: 0,
                                cameraDirection: 0,
                                popoverOptions: CameraPopoverOptions,
                                saveToPhotoAlbum: true
                            };
                            cameraService.getPicture(cameraOptions).then(function (imageData) {
                                $scope.device.imageURI = imageData;
                                deviceService.serialize();
                                $rootScope.$broadcast('devices.refresh', $scope.device);
                            }, function (err) {
                                console.log(err);
                            });
                        }
                    } else if (index == 1) {
                        var cameraOptions = {
                            quality: 100,
                            destinationType: Camera.DestinationType.FILE_URI,
                            sourceType: Camera.PictureSourceType.CAMERA,
                            allowEdit: true,
                            encodingType: Camera.EncodingType.JPEG,
                            targetWidth: 300,
                            targetHeight: 300,
                            mediaType: 0,
                            cameraDirection: 0,
                            popoverOptions: CameraPopoverOptions,
                            saveToPhotoAlbum: true
                        };

                        cameraService.getPicture(cameraOptions).then(function (imageData) {
                            $scope.device.imageURI = imageData;
                            deviceService.serialize();
                            $rootScope.$broadcast('devices.refresh', $scope.device);
                        }, function (err) {
                            console.log(err);
                        });

                    }
                    return true;
                },
                destructiveButtonClicked: function () {
                    return true;
                }
            });
        };
        $scope.ConfigClickMain = function () {
            $state.go("main");
        };
        $scope.delDeviceInfo = function(deviceId) {
            itemService.del(deviceId);
            deviceService.del(deviceId);
            deviceService.serialize();
            $rootScope.$broadcast('devices.refresh', null);
            $timeout(function() {
                $ionicSlideBoxDelegate.$getByHandle("main_slide_box").slide(0);
            }, 500);
            $state.go("main");
        };
        $scope.onClickedDelete = function (deviceId) {
            system.booleanBound=2;
            systemService.serialize();

            var item = itemService.get(deviceId);
            if (item.timerRSSI != null) {
                $interval.cancel(item.timerRSSI);
                item.timerRSSI = null;
            }

            if (currentPlatform == 'ios' || currentPlatform == 'android') {
                $ionicLoading.show({template: "<ion-spinner icon='ios'></ion-spinner>"});

                bleService.disconnect(deviceId).then(function (result) {
                    $ionicLoading.hide();
                    $scope.delDeviceInfo(deviceId);
                }, function (err) {
                    $timeout(function () {
                        $ionicLoading.hide();
                        $scope.delDeviceInfo(deviceId);

                    }, 500);
                });
            }

        };
        $scope.onGoKey = function(){
            $state.go("key",{
                deviceId:$stateParams.id
            });
        };

        $scope.updateLanguages = function (optionSelected) {
        };
    });