angular.module('ufind1.controllers', ['baiduMap'])

    .controller('mapCtrl', function ($state,$scope, $timeout, locationService, deviceService, $stateParams) {

        var longitude;
        var latitude;
        var time;
        var isBaiduPoint;
        $scope.MapOnClickConfig  = function (){
            $state.go("config",{
                    id:$stateParams.deviceId
                }
                );
        };
        var currentPlatform = ionic.Platform.platform();
        if (currentPlatform == 'win32' || currentPlatform == 'macintel') {
            longitude = 114.2249847839605;
            latitude = 22.68722230099834;
        } else {
            var device = deviceService.get($stateParams.deviceId);
            longitude = device.lon;
            latitude = device.lati;
            time = device.time;
            isBaiduPoint = device.isBaiduPoint;
            if (typeof(longitude) == "undefined" && typeof(latitude) == "undefined") {
                longitude = locationService.getLon();
                latitude = locationService.getLat();
                time = locationService.getTime();
                isBaiduPoint = locationService.getIsBaiduPoint();
            }


        }

        $scope.mapOptions = {
            center: {
                longitude: longitude,
                latitude: latitude
            },
            isBaiduPoint: isBaiduPoint,
            zoom: 17,
            city: 'shenzhen',
            markers: [
                {
                    longitude: longitude,
                    latitude: latitude,
                    width: 49,
                    height: 60,
                    title: '断开位置(' + time + ')'
                }
            ]
        };
    });