angular.module('ufind1.controllers')

    .controller('searchCtrl', function ($rootScope, $q, $timeout, $scope, $state, bleService, deviceService) {
        $scope.doRefresh = function () {
            $scope.items = [];
            var currentPlatform = ionic.Platform.platform();
            if (currentPlatform == 'win32' || currentPlatform == 'macintel') {
                var peripheral = {
                    id: "C9C3D476-A8FC-D95D-8AC6-999988887777",
                    name: "win32test",
                    imageURI: "",
                    appAlert: true,
                    alertTime: "4S",
                    reconnectAlert: true,
                    itemAlert: true,
                    alertRange : "3"
                };

                if (deviceService.get(peripheral.id) === null) {
                    $scope.items = $scope.items.concat(peripheral);
                }

                $scope.$broadcast('scroll.refreshComplete');

            } else {
                bleService.scan([], 5).then(function () {
                    console.log("BLE Scan Finished");
                    $scope.$broadcast('scroll.refreshComplete');
                }, function (error) {
                    console.log("BLE Scan Failed:", error);
                    $scope.$broadcast('scroll.refreshComplete');
                }, function (peripheral) {
                    if (peripheral.name == "ufind0"|| peripheral.advertising["kCBAdvDataLocalName"] == "ufind0" || peripheral.name == "ufind1"|| peripheral.advertising["kCBAdvDataLocalName"] == "ufind1") {
                        if (deviceService.get(peripheral.id) === null) {
                            console.log("I Found " + JSON.stringify(peripheral));
                            var device = {};
                            device.id = peripheral.id;
                            device.rawName = peripheral.name;
                            device.name = "";
                            device.imageURI = "";
                            device.appAlert = true;
                            device.alertTime = "4S";
                            device.reconnectAlert = true;
                            device.itemAlert = true;
                            device.alertRange = "3";
                            device.zeroButton = '0';
                            device.oneButton = '-1';
                            device.twoButton = '-2';
                            device.threeButton = '0';
                            device.fourButton = '-1';
                            device.fiveButton = '-2';
                            device.sixButton = '0';
                            device.sevenButton ='1';
                            device.eightButton = '-2';
                            $scope.items = $scope.items.concat(device);
                        }
                    }
                });
            }
        };
        $scope.searchonClickMain = function () {
            $state.go("main");
        };

        $scope.$on('$ionicView.beforeEnter', function () {
            $scope.doRefresh();
        });

        $scope.onClickedConnect = function (device) {
            $state.go("bond", {
                device: device
            });
        }
    });