angular.module('ufind1.controllers')

    .controller('silentAreaCtrl', function ($scope, $stateParams, $state, $translate, bleService, systemService) {

        var currentPlatform = ionic.Platform.platform();
        var system = systemService.all();
        $scope.data = {silentArea: system.silentArea};

        $scope.update = function () {
            var sys = systemService.all();
            if (currentPlatform == 'win32' || currentPlatform == 'macintel' || currentPlatform == 'ios') {
                $scope.silentWifi1 = (system.silentArea1x0 + system.silentArea1y0) ? $translate.instant("already_add_area","","","") : "";
                $scope.silentWifi2 = (system.silentArea2x0 + system.silentArea2y0) ? $translate.instant("already_add_area","","","") : "";
                $scope.silentWifi3 = (system.silentArea3x0 + system.silentArea3y0) ? $translate.instant("already_add_area","","","") : "";
            }
            else if (currentPlatform == 'android') {
                $scope.silentWifi1 = sys.silentWifi1;
                $scope.silentWifi2 = sys.silentWifi2;
                $scope.silentWifi3 = sys.silentWifi3;
            }
        };

        $scope.$on('$stateChangeSuccess', $scope.update);
        $scope.silentonClickSetting = function () {
            $state.go("setting");
        };
        $scope.update();

        $scope.onClickedSilentArea = function(idx) {
    		var currentPlatform = ionic.Platform.platform();
    		console.log("silentAreaCtrl currentPlatform: " + currentPlatform);
            console.log("silentAreaCtrl idx: " + idx);
    		if (currentPlatform == 'win32' || currentPlatform == 'macintel' || currentPlatform == 'ios') {
    			$state.go("area", {id: idx}, {reload: true});
    		}
    		else if (currentPlatform == 'android') {
    			$state.go("wifi", {id: idx}, {reload: true});
    		}
    	};

        $scope.onToggleSilentArea = function () {
            var system = systemService.all();
            console.log("cmdSilentArea: " + $scope.data.silentArea);

            if (currentPlatform == 'ios' || currentPlatform == 'android') {
                bleService.setOption("", "cmdSilentArea", $scope.data.silentArea ? "1" : "0")
            }

            system.silentArea = $scope.data.silentArea;
            systemService.serialize();
        };
    });
