angular.module('ufind1.controllers')

    .controller('silentTimeCtrl', function ($scope, $stateParams, $ionicPopup, $translate,
                                            systemService, bleService,$state) {

        var system = systemService.all();
        $scope.system = {silentTime: system.silentTime};
        $scope.startHour1 = system.silentStartHour1;
        $scope.startMinute1 = system.silentStartMinute1;
        $scope.stopHour1 = system.silentStopHour1;
        $scope.stopMinute1 = system.silentStopMinute1;
        $scope.startHour2 = system.silentStartHour2;
        $scope.startMinute2 = system.silentStartMinute2;
        $scope.stopHour2 = system.silentStopHour2;
        $scope.stopMinute2 = system.silentStopMinute2;


        $scope.silenttOnClickConfig  = function (){
            $state.go("setting");
        };
        $scope.timePickerObject1 = {
            inputEpochTime: ((new Date()).getHours() * 60 * 60 + (new Date()).getMinutes() * 60),
            step: 10,
            titleLabel: $translate.instant('silent_time_timePickerTitle',"","","") + "1",
            closeLabel: $translate.instant('cancel',"","",""),
            setLabel: $translate.instant('ok',"","",""),
            setButtonType: 'button-positive',
            closeButtonType: 'button-stable',
            startHour: $scope.startHour1,
            startMinutel: $scope.startMinute1,
            stopHour: $scope.stopHour1,
            stopMinutel: $scope.stopMinute1,
            callback: function (startHour, startMinute, stopHour, stopMinute) {
                if (typeof(startHour) === 'undefined' || typeof(startMinute) === 'undefined' || typeof(stopHour) === 'undefined' || typeof(stopMinute) === 'undefined') {
                    console.log('Time not selected');
                } else {
                    $scope.startHour1 = startHour;
                    $scope.startMinute1 = startMinute;
                    $scope.stopHour1 = stopHour;
                    $scope.stopMinute1 = stopMinute;

                    $scope.timePickerObject1.startHour = startHour;
                    $scope.timePickerObject1.startMinutel = startMinute;
                    $scope.timePickerObject1.stopHour = stopHour;
                    $scope.timePickerObject1.stopMinutel = stopMinute;

                    system.silentStartHour1 = startHour;
                    system.silentStartMinute1 = startMinute;
                    system.silentStopHour1 = stopHour;
                    system.silentStopMinute1 = stopMinute;

                    if (angular.isDefined(bleService.setOption)) {
                        bleService.setOption("", "cmdSilentStartHour1", startHour);
                        bleService.setOption("", "cmdSilentStartMinute1", startMinute);
                        bleService.setOption("", "cmdSilentStopHour1", stopHour);
                        bleService.setOption("", "cmdSilentStopMinute1", stopMinute);
                    }

                    systemService.serialize();
                }
            }
        };

        $scope.timePickerObject2 = {
            inputEpochTime: ((new Date()).getHours() * 60 * 60 + (new Date()).getMinutes() * 60),
            step: 10,
            titleLabel: $translate.instant('silent_time_timePickerTitle',"","","") + "2",
            closeLabel: $translate.instant('cancel',"","",""),
            setLabel: $translate.instant('ok',"","",""),
            setButtonType: 'button-positive',
            closeButtonType: 'button-stable',
            startHour: $scope.startHour2,
            startMinutel: $scope.startMinute2,
            stopHour: $scope.stopHour2,
            stopMinutel: $scope.stopMinute2,
            callback: function (startHour, startMinute, stopHour, stopMinute) {
                if (typeof(startHour) === 'undefined' || typeof(startMinute) === 'undefined' || typeof(stopHour) === 'undefined' || typeof(stopMinute) === 'undefined') {
                    console.log('Time not selected');
                } else {
                    $scope.startHour2 = startHour;
                    $scope.startMinute2 = startMinute;
                    $scope.stopHour2 = stopHour;
                    $scope.stopMinute2 = stopMinute;

                    $scope.timePickerObject2.startHour = startHour;
                    $scope.timePickerObject2.startMinutel = startMinute;
                    $scope.timePickerObject2.stopHour = stopHour;
                    $scope.timePickerObject2.stopMinutel = stopMinute;

                    system.silentStartHour2 = startHour;
                    system.silentStartMinute2 = startMinute;
                    system.silentStopHour2 = stopHour;
                    system.silentStopMinute2 = stopMinute;

                    if (angular.isDefined(bleService.setOption)) {
                        bleService.setOption("", "cmdSilentStartHour2", startHour);
                        bleService.setOption("", "cmdSilentStartMinute2", startMinute);
                        bleService.setOption("", "cmdSilentStopHour2", stopHour);
                        bleService.setOption("", "cmdSilentStopMinute2", stopMinute);
                    }

                    systemService.serialize();
                }
            }
        };

        parseWeekDay = function (weekday) {
            var str = "";
            console.log(weekday);
            if (weekday == 127) return $translate.instant('everyday',"","","");
            if (weekday & 1) str += $translate.instant('sunday',"","","");
            if (weekday & 2) str += $translate.instant('monday',"","","");
            if (weekday & 4) str += $translate.instant('tuesday',"","","");
            if (weekday & 8) str += $translate.instant('wednesday',"","","");
            if (weekday & 16) str += $translate.instant('thursday',"","","");
            if (weekday & 32) str += $translate.instant('friday',"","","");
            if (weekday & 64) str += $translate.instant('saturday',"","","");
            return str;
        };

        $scope.weekDay1 = parseWeekDay(system.silentWeekDay1);

        $scope.weekDay2 = parseWeekDay(system.silentWeekDay2);

        $scope.weekPickerObject1 = {
            titleLabel: $translate.instant('silent_time_weekPickerTitle',"","","") + "1",
            closeLabel: $translate.instant('cancel',"","",""),
            setLabel: $translate.instant('ok',"","",""),
            setButtonType: 'button-positive',
            closeButtonType: 'button-stable',
            value: system.silentWeekDay1,
            callback: function (weekday) {
                if (typeof(weekday) === 'undefined') {
                    console.log('Weekday not selected');
                } else {
                    $scope.weekDay1 = parseWeekDay(weekday);
                    system.silentWeekDay1 = weekday;
                    $scope.weekPickerObject1.value = weekday;
                    if (angular.isDefined(bleService.setOption)) {
                        bleService.setOption("", "cmdSilentWeekDay1", weekday);
                    }

                    systemService.serialize();
                }
            }
        };

        $scope.weekPickerObject2 = {
            titleLabel: $translate.instant('silent_time_weekPickerTitle',"","","") + "2",
            closeLabel: $translate.instant('cancel',"","",""),
            setLabel: $translate.instant('ok',"","",""),
            setButtonType: 'button-positive',
            closeButtonType: 'button-stable',
            value: system.silentWeekDay2,
            callback: function (weekday) {
                if (typeof(weekday) === 'undefined') {
                    console.log('Weekday not selected');
                } else {
                    $scope.weekDay2 = parseWeekDay(weekday);
                    system.silentWeekDay2 = weekday;
                    $scope.weekPickerObject2.value = weekday;
                    if (angular.isDefined(bleService.setOption)) {
                        bleService.setOption("", "cmdSilentWeekDay2", weekday);
                    }

                    systemService.serialize();
                }
            }
        };

        $scope.onClickSilentTime = function () {
            if (angular.isDefined(bleService.setOption)) {
                bleService.setOption("", "cmdSilentTime", $scope.system.silentTime ? "1" : "0")
            }

            system.silentTime = $scope.system.silentTime;
            systemService.serialize();
        };
    });