angular.module('timepicker', ['ionic'])

.directive('timepicker', ['$ionicPopup', 'systemService', function($ionicPopup, systemService) {
	return {
		restrict: 'AE',
		replace: true,
		scope: {
			inputObj: "=inputObj"
		},
		link: function(scope, element, attrs) {

			var currentEpoch = ((new Date()).getHours() * 60 * 60) + ((new Date()).getMinutes() * 60);

			scope.inputEpochTime = scope.inputObj.inputEpochTime ? scope.inputObj.inputEpochTime : currentEpoch;
			scope.step = scope.inputObj.step ? scope.inputObj.step : 15;
			scope.titleLabel = scope.inputObj.titleLabel ? scope.inputObj.titleLabel : 'Time Picker';
			scope.setLabel = scope.inputObj.setLabel ? scope.inputObj.setLabel : 'Set';
			scope.closeLabel = scope.inputObj.closeLabel ? scope.inputObj.closeLabel : 'Close';
			scope.setButtonType = scope.inputObj.setButtonType ? scope.inputObj.setButtonType : 'button-positive';
			scope.closeButtonType = scope.inputObj.closeButtonType ? scope.inputObj.closeButtonType : 'button-stable';

			var obj = {
				epochTime: scope.inputEpochTime,
				step: scope.step
			};

			scope.startTime = {
				hours: 0,
				minutes: 0
			};

			scope.stopTime = {
				hours: 0,
				minutes: 0
			};

			var objDate = new Date(obj.epochTime * 1000); // Epoch time in milliseconds.

			scope.increaseStartHours = function() {
				scope.startTime.hours = Number(scope.startTime.hours);
				scope.startTime.hours = (scope.startTime.hours + 1) % 24;
				scope.startTime.hours = (scope.startTime.hours < 10) ? ('0' + scope.startTime.hours) : scope.startTime.hours;
			};

			scope.decreaseStartHours = function() {
				scope.startTime.hours = Number(scope.startTime.hours);
				scope.startTime.hours = (scope.startTime.hours + 23) % 24;
				scope.startTime.hours = (scope.startTime.hours < 10) ? ('0' + scope.startTime.hours) : scope.startTime.hours;
			};

			scope.increaseStartMinutes = function() {
				scope.startTime.minutes = Number(scope.startTime.minutes);
				scope.startTime.minutes = (scope.startTime.minutes + obj.step) % 60;
				scope.startTime.minutes = (scope.startTime.minutes < 10) ? ('0' + scope.startTime.minutes) : scope.startTime.minutes;
			};

			scope.decreaseStartMinutes = function() {
				scope.startTime.minutes = Number(scope.startTime.minutes);
				scope.startTime.minutes = (scope.startTime.minutes + (60 - obj.step)) % 60;
				scope.startTime.minutes = (scope.startTime.minutes < 10) ? ('0' + scope.startTime.minutes) : scope.startTime.minutes;
			};

			scope.increaseStopHours = function() {
				scope.stopTime.hours = Number(scope.stopTime.hours);
				scope.stopTime.hours = (scope.stopTime.hours + 1) % 24;
				scope.stopTime.hours = (scope.stopTime.hours < 10) ? ('0' + scope.stopTime.hours) : scope.stopTime.hours;
			};

			scope.decreaseStopHours = function() {
				scope.stopTime.hours = Number(scope.stopTime.hours);
				scope.stopTime.hours = (scope.stopTime.hours + 23) % 24;
				scope.stopTime.hours = (scope.stopTime.hours < 10) ? ('0' + scope.stopTime.hours) : scope.stopTime.hours;
			};

			scope.increaseStopMinutes = function() {
				scope.stopTime.minutes = Number(scope.stopTime.minutes);
				scope.stopTime.minutes = (scope.stopTime.minutes + obj.step) % 60;
				scope.stopTime.minutes = (scope.stopTime.minutes < 10) ? ('0' + scope.stopTime.minutes) : scope.stopTime.minutes;
			};

			scope.decreaseStopMinutes = function() {
				scope.stopTime.minutes = Number(scope.stopTime.minutes);
				scope.stopTime.minutes = (scope.stopTime.minutes + (60 - obj.step)) % 60;
				scope.stopTime.minutes = (scope.stopTime.minutes < 10) ? ('0' + scope.stopTime.minutes) : scope.stopTime.minutes;
			};

			element.on("click", function() {
				if (typeof scope.inputObj.inputEpochTime === 'undefined' || scope.inputObj.inputEpochTime === null) {
					objDate = new Date();
					console.log("click no time obj");
				} else {
					console.log("click time obj =>" + JSON.stringify(scope.inputObj));
					objDate = new Date(scope.inputObj.inputEpochTime * 1000);
				}

				/*scope.startTime.hours = (objDate.getUTCHours());
				scope.startTime.minutes = (objDate.getUTCMinutes());
				scope.startTime.hours = (scope.startTime.hours < 10) ? ("0" + scope.startTime.hours) : (scope.startTime.hours);
				scope.startTime.minutes = (scope.startTime.minutes < 10) ? ("0" + scope.startTime.minutes) : (scope.startTime.minutes);

				scope.stopTime.hours = (objDate.getUTCHours());
				scope.stopTime.minutes = (objDate.getUTCMinutes());
				scope.stopTime.hours = (scope.stopTime.hours < 10) ? ("0" + scope.stopTime.hours) : (scope.stopTime.hours);
				scope.stopTime.minutes = (scope.stopTime.minutes < 10) ? ("0" + scope.stopTime.minutes) : (scope.stopTime.minutes);*/

				scope.startTime.hours = scope.inputObj.startHour;
				scope.startTime.minutes = scope.inputObj.startMinutel;
				scope.stopTime.hours = scope.inputObj.stopHour;
				scope.stopTime.minutes = scope.inputObj.stopMinutel;

				$ionicPopup.show({
					templateUrl: 'templates/timepicker.html',
					title: scope.titleLabel,
					subTitle: '',
					scope: scope,
					buttons: [{
						text: scope.closeLabel,
						type: scope.closeButtonType,
						onTap: function(e) {
							scope.inputObj.callback(undefined, undefined);
						}
					}, {
						text: scope.setLabel,
						type: scope.setButtonType,
						onTap: function(e) {
							scope.loadingContent = true;
							scope.inputObj.callback(scope.startTime.hours, scope.startTime.minutes, scope.stopTime.hours, scope.stopTime.minutes);
						}
					}]
				});
			});
		}
	};
}]);