angular.module('ufind1')

    .config(function ($stateProvider, $urlRouterProvider) {
        $stateProvider
            .state("main", {
                url: "/",
                templateUrl: "templates/main.html",
                controller: "mainCtrl"
            })
            .state("setting", {
                url: "/setting",
                templateUrl: "templates/setting.html",
                controller: "settingCtrl"
            })
            .state("private", {
                url: "/private",
                templateUrl: "templates/private.html",
                controller: "privateCtrl"
            })
            .state("protocol", {
                url: "/protocol",
                templateUrl: "templates/protocol.html",
                controller: "protocolCtrl"
            })
            .state("feedback", {
                url: "/feedback",
                templateUrl: "templates/feedback.html",
                controller: "feedbackCtrl"
            })
            .state("silent_area", {
                url: "/silent_area",
                templateUrl: "templates/silent_area.html",
                controller: "silentAreaCtrl"
            })
            .state("area", {
                url: "/area/:id",
                templateUrl: "templates/area.html",
                controller: "areaCtrl"
            })
            .state("wifi", {
                url: "/wifi/:id",
                templateUrl: "templates/wifi.html",
                controller: "wifiCtrl"
            })
            .state("silent_time", {
                url: "/silent_time",
                templateUrl: "templates/silent_time.html",
                controller: "silentTimeCtrl"
            })
            .state("search", {
                cache: 'false',
                url: "/search",
                templateUrl: "templates/search.html",
                controller: "searchCtrl"
            })
            .state("config", {
                url: "/config/:id",
                templateUrl: "templates/config.html",
                controller: "configCtrl"
            })
            .state("map", {
                url: "/map/:deviceId",
                templateUrl: "templates/map.html",
                controller: "mapCtrl"
            })
            .state("language", {
                url: "/language",
                templateUrl: "templates/language.html",
                controller: "languageCtrl"
            })
            .state("alert", {
                url: "/alert/:deviceId",
                templateUrl: "templates/alert.html",
                controller: "alertCtrl"
            })
            .state("key", {
                cache: 'false',
                url: "/key/:deviceId/",
                templateUrl: "templates/key.html",
                controller: "keyCtrl"
            })
            .state("action", {
                cache:false,
                url: "/action/:deviceId/:keyId/",
                templateUrl: "templates/action.html",
                controller: "actionCtrl"
            })
            .state("bond", {
                url: "/bond",
                templateUrl: "templates/bond.html",
                controller: "bondCtrl",
                params: {'device': null }
            })
            .state("faq", {
                url: "/faq",
                cache: 'false',
                templateUrl: "templates/faq.html",
                controller: "faqCtrl"
            })
            .state("detail", {
                url: "/faq/:deviceId",
                templateUrl: "templates/detail.html",
                controller: "detailCtrl"
            })
            .state("about", {
                url: "/about",
                templateUrl: "templates/about.html",
                controller: "aboutCtrl"
            })
            .state("update", {
                url: "/update",
                templateUrl: "templates/update.html",
                controller: "updateCtrl"
            })
            .state("directioncall", {
                cache:false,
                url: "/directioncall",
                templateUrl: "templates/directioncall.html",
                controller: "directioncallCtrl"
            })
           .state("directionsms", {
                cache:false,
            url: "/directionsms",
            templateUrl: "templates/directionsms.html",
            controller: "directionsmsCtrl"
           })
        .state("virtualcall", {
                cache:false,
            url: "/virtualcall",
            templateUrl: "templates/virtualcall.html",
            controller: "virtualcallCtrl"
        });

        $urlRouterProvider.otherwise("/");
    });